Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.thoughtworks.xstream.io.xml
Class SaxWriter

    java.lang.Object
      com.thoughtworks.xstream.io.xml.AbstractXmlWriter
          com.thoughtworks.xstream.io.xml.SaxWriter

All Implemented Interfaces:
  ExtendedHierarchicalStreamWriter, HierarchicalStreamWriter, XmlFriendlyWriter, XMLReader

    public final class SaxWriter

extends AbstractXmlWriter
implements XMLReader

A SAX `parser` that acts as an XStream `HierarchicalStreamWriter` to enable direct generation of a SAX event flow from the XStream serialization of a list of list of Java objects.

As a custom SAX parser, this class ignores the arguments of the two standard parse methods (`parse(java.lang.String)` and `parse(org.xml.sax.InputSource)`) but relies on a proprietary SAX property `SOURCE_OBJECT_LIST_PROPERTY` to define the list of objects to serialize.

Configuration of this SAX parser is achieved through the standard `SAX property mechanism`. While specific setter methods require direct access to the parser instance, SAX properties support configuration settings to be propagated through a chain of `filters` down to the underlying parser object.

This mechanism shall be used to configure the `objects to be serialized` as well as the `XStream facade`.

Author:
  Laurent Bihanic

Field Summary
`static String` | `CONFIGURED_XSTREAM_PROPERTY` The `SAX property` to configure the XStream facade to be used for object serialization.
`static String` | `SOURCE_OBJECT_LIST_PROPERTY` The `SAX property` to configure the list of Java objects to serialize.

Constructor Summary
`SaxWriter()`
`SaxWriter(boolean includeEnclosingDocument)`
`SaxWriter(boolean includeEnclosingDocument, XmlFriendlyReplacer replacer)`
`SaxWriter(XmlFriendlyReplacer replacer)`

Method Summary
`void` | `addAttribute(String name, String value)`
`void` | `close()` Close the writer, if necessary.
`void` | `endNode()`
`void` | `flush()` Flush the writer, if necessary.
`ContentHandler` | `getContentHandler()` Returns the current content handler.
`DTDHandler` | `getDTDHandler()` Returns the current DTD handler.
`EntityResolver` | `getEntityResolver()` Returns the current entity resolver.
`ErrorHandler` | `getErrorHandler()` Returns the current error handler.
`boolean` | `getFeature(String name)` Looks up the value of a feature.
`Object` | `getProperty(String name)` Looks up the value of a property.
`void` | `parse(InputSource input)` Parse an XML document.
`void` | `parse(String systemId)` Parses an XML document from a system identifier (URI).
`void` | `setContentHandler(ContentHandler handler)` Allows an application to register a content event handler.
`void` | `setDTDHandler(DTDHandler handler)` Allows an application to register a DTD event handler.
`void` | `setEntityResolver(EntityResolver resolver)` Allows an application to register an entity resolver.
`void` | `setErrorHandler(ErrorHandler handler)` Allows an application to register an error event handler.
`void` | `setFeature(String name, boolean value)` Sets the state of a feature.
`void` | `setProperty(String name, Object value)` Sets the value of a property.
`void` | `setValue(String text)` Write the value (text content) of the current node.
`void` | `startNode(String name)`

Methods inherited from class com.thoughtworks.xstream.io.xml.AbstractXmlWriter
`escapeXmlName, startNode, underlyingWriter`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### CONFIGURED_XSTREAM_PROPERTY

    public static final String CONFIGURED_XSTREAM_PROPERTY

  The `SAX property` to configure the XStream facade to be used for object serialization. If the property is not set, a new XStream facade will be allocated for each parse.

  See Also:
    Constant Field Values

### SOURCE_OBJECT_LIST_PROPERTY

    public static final String SOURCE_OBJECT_LIST_PROPERTY

  The `SAX property` to configure the list of Java objects to serialize. Setting this property prior invoking one of the parse() methods is mandatory.

  See Also:
    `parse(java.lang.String)`, `parse(org.xml.sax.InputSource)`, Constant Field Values

Constructor Detail

### SaxWriter

    public SaxWriter(XmlFriendlyReplacer replacer)

### SaxWriter

    public SaxWriter(boolean includeEnclosingDocument,
                     XmlFriendlyReplacer replacer)

### SaxWriter

    public SaxWriter(boolean includeEnclosingDocument)

### SaxWriter

    public SaxWriter()

Method Detail

### setFeature

    public void setFeature(String name,
                           boolean value)
                    throws SAXNotRecognizedException

  Sets the state of a feature.

  The feature name is any fully-qualified URI.

  All XMLReaders are required to support setting `http://xml.org/sax/features/namespaces` to `true` and `http://xml.org/sax/features/namespace-prefixes` to `false`.

  Some feature values may be immutable or mutable only in specific contexts, such as before, during, or after a parse.

  Note: This implementation only supports the two mandatory SAX features.

  Specified by:
    `setFeature` in interface `XMLReader`
  Parameters:
    `name` - the feature name, which is a fully-qualified URI.
    `value` - the requested state of the feature (true or false).
  Throws:
    `SAXNotRecognizedException` - when the XMLReader does not recognize the feature name.
  See Also:
    `getFeature(java.lang.String)`

### getFeature

    public boolean getFeature(String name)
                       throws SAXNotRecognizedException

  Looks up the value of a feature.

  The feature name is any fully-qualified URI. It is possible for an XMLReader to recognize a feature name but to be unable to return its value; this is especially true in the case of an adapter for a SAX1 Parser, which has no way of knowing whether the underlying parser is performing validation or expanding external entities.

  All XMLReaders are required to recognize the `http://xml.org/sax/features/namespaces` and the `http://xml.org/sax/features/namespace-prefixes` feature names.

  Some feature values may be available only in specific contexts, such as before, during, or after a parse.

  Implementors are free (and encouraged) to invent their own features, using names built on their own URIs.

  Specified by:
    `getFeature` in interface `XMLReader`
  Parameters:
    `name` - the feature name, which is a fully-qualified URI.
  Returns:
    the current state of the feature (true or false).
  Throws:
    `SAXNotRecognizedException` - when the XMLReader does not recognize the feature name.
  See Also:
    `setFeature(java.lang.String, boolean)`

### setProperty

    public void setProperty(String name,
                            Object value)
                     throws SAXNotRecognizedException,
                            SAXNotSupportedException

  Sets the value of a property.

  The property name is any fully-qualified URI. It is possible for an XMLReader to recognize a property name but to be unable to set its value.

  XMLReaders are not required to recognize setting any specific property names, though a core set is provided with SAX2.

  Some property values may be immutable or mutable only in specific contexts, such as before, during, or after a parse.

  This method is also the standard mechanism for setting extended handlers.

  Note: This implementation only supports two (proprietary) properties: `CONFIGURED_XSTREAM_PROPERTY` and `SOURCE_OBJECT_LIST_PROPERTY`.

  Specified by:
    `setProperty` in interface `XMLReader`
  Parameters:
    `name` - the property name, which is a fully-qualified URI.
    `value` - the requested value for the property.
  Throws:
    `SAXNotRecognizedException` - when the XMLReader does not recognize the property name.
    `SAXNotSupportedException` - when the XMLReader recognizes the property name but cannot set the requested value.
  See Also:
    `getProperty(java.lang.String)`

### getProperty

    public Object getProperty(String name)
                       throws SAXNotRecognizedException

  Looks up the value of a property.

  The property name is any fully-qualified URI. It is possible for an XMLReader to recognize a property name but to be unable to return its state.

  XMLReaders are not required to recognize any specific property names, though an initial core set is documented for SAX2.

  Some property values may be available only in specific contexts, such as before, during, or after a parse.

  Implementors are free (and encouraged) to invent their own properties, using names built on their own URIs.

  Specified by:
    `getProperty` in interface `XMLReader`
  Parameters:
    `name` - the property name, which is a fully-qualified URI.
  Returns:
    the current value of the property.
  Throws:
    `SAXNotRecognizedException` - when the XMLReader does not recognize the property name.
  See Also:
    `getProperty(java.lang.String)`

### setEntityResolver

    public void setEntityResolver(EntityResolver resolver)

  Allows an application to register an entity resolver.

  If the application does not register an entity resolver, the XMLReader will perform its own default resolution.

  Applications may register a new or different resolver in the middle of a parse, and the SAX parser must begin using the new resolver immediately.

  Specified by:
    `setEntityResolver` in interface `XMLReader`
  Parameters:
    `resolver` - the entity resolver.
  Throws:
    `NullPointerException` - if the resolver argument is `null`.
  See Also:
    `getEntityResolver()`

### getEntityResolver

    public EntityResolver getEntityResolver()

  Returns the current entity resolver.

  Specified by:
    `getEntityResolver` in interface `XMLReader`
  Returns:
    the current entity resolver, or `null` if none has been registered.
  See Also:
    `setEntityResolver(org.xml.sax.EntityResolver)`

### setDTDHandler

    public void setDTDHandler(DTDHandler handler)

  Allows an application to register a DTD event handler.

  If the application does not register a DTD handler, all DTD events reported by the SAX parser will be silently ignored.

  Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

  Specified by:
    `setDTDHandler` in interface `XMLReader`
  Parameters:
    `handler` - the DTD handler.
  Throws:
    `NullPointerException` - if the handler argument is `null`.
  See Also:
    `getDTDHandler()`

### getDTDHandler

    public DTDHandler getDTDHandler()

  Returns the current DTD handler.

  Specified by:
    `getDTDHandler` in interface `XMLReader`
  Returns:
    the current DTD handler, or `null` if none has been registered.
  See Also:
    `setDTDHandler(org.xml.sax.DTDHandler)`

### setContentHandler

    public void setContentHandler(ContentHandler handler)

  Allows an application to register a content event handler.

  If the application does not register a content handler, all content events reported by the SAX parser will be silently ignored.

  Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

  Specified by:
    `setContentHandler` in interface `XMLReader`
  Parameters:
    `handler` - the content handler.
  Throws:
    `NullPointerException` - if the handler argument is `null`.
  See Also:
    `getContentHandler()`

### getContentHandler

    public ContentHandler getContentHandler()

  Returns the current content handler.

  Specified by:
    `getContentHandler` in interface `XMLReader`
  Returns:
    the current content handler, or `null` if none has been registered.
  See Also:
    `setContentHandler(org.xml.sax.ContentHandler)`

### setErrorHandler

    public void setErrorHandler(ErrorHandler handler)

  Allows an application to register an error event handler.

  If the application does not register an error handler, all error events reported by the SAX parser will be silently ignored; however, normal processing may not continue. It is highly recommended that all SAX applications implement an error handler to avoid unexpected bugs.

  Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

  Specified by:
    `setErrorHandler` in interface `XMLReader`
  Parameters:
    `handler` - the error handler.
  Throws:
    `NullPointerException` - if the handler argument is `null`.
  See Also:
    `getErrorHandler()`

### getErrorHandler

    public ErrorHandler getErrorHandler()

  Returns the current error handler.

  Specified by:
    `getErrorHandler` in interface `XMLReader`
  Returns:
    the current error handler, or `null` if none has been registered.
  See Also:
    `setErrorHandler(org.xml.sax.ErrorHandler)`

### parse

    public void parse(String systemId)
               throws SAXException

  Parses an XML document from a system identifier (URI).

  This method is a shortcut for the common case of reading a document from a system identifier. It is the exact equivalent of the following:

  >         parse(new InputSource(systemId));

  If the system identifier is a URL, it must be fully resolved by the application before it is passed to the parser.

  Note: As a custom SAX parser, this class ignores the `systemId` argument of this method and relies on the proprietary SAX property `SOURCE_OBJECT_LIST_PROPERTY`) to define the list of objects to serialize.

  Specified by:
    `parse` in interface `XMLReader`
  Parameters:
    `systemId` - the system identifier (URI).
  Throws:
    `SAXException` - Any SAX exception, possibly wrapping another exception.
  See Also:
    `parse(org.xml.sax.InputSource)`

### parse

    public void parse(InputSource input)
               throws SAXException

  Parse an XML document.

  The application can use this method to instruct the XML reader to begin parsing an XML document from any valid input source (a character stream, a byte stream, or a URI).

  Applications may not invoke this method while a parse is in progress (they should create a new XMLReader instead for each nested XML document). Once a parse is complete, an application may reuse the same XMLReader object, possibly with a different input source.

  During the parse, the XMLReader will provide information about the XML document through the registered event handlers.

  This method is synchronous: it will not return until parsing has ended. If a client application wants to terminate parsing early, it should throw an exception.

  Note: As a custom SAX parser, this class ignores the `source` argument of this method and relies on the proprietary SAX property `SOURCE_OBJECT_LIST_PROPERTY`) to define the list of objects to serialize.

  Specified by:
    `parse` in interface `XMLReader`
  Parameters:
    `input` - The input source for the top-level of the XML document.
  Throws:
    `SAXException` - Any SAX exception, possibly wrapping another exception.
  See Also:
    `InputSource`, `parse(java.lang.String)`, `setEntityResolver(org.xml.sax.EntityResolver)`, `setDTDHandler(org.xml.sax.DTDHandler)`, `setContentHandler(org.xml.sax.ContentHandler)`, `setErrorHandler(org.xml.sax.ErrorHandler)`

### startNode

    public void startNode(String name)

  Specified by:
    `startNode` in interface `HierarchicalStreamWriter`

### addAttribute

    public void addAttribute(String name,
                             String value)

  Specified by:
    `addAttribute` in interface `HierarchicalStreamWriter`

### setValue

    public void setValue(String text)

  Description copied from interface: `HierarchicalStreamWriter`
  Write the value (text content) of the current node.

  Specified by:
    `setValue` in interface `HierarchicalStreamWriter`

### endNode

    public void endNode()

  Specified by:
    `endNode` in interface `HierarchicalStreamWriter`

### flush

    public void flush()

  Description copied from interface: `HierarchicalStreamWriter`
  Flush the writer, if necessary.

  Specified by:
    `flush` in interface `HierarchicalStreamWriter`

### close

    public void close()

  Description copied from interface: `HierarchicalStreamWriter`
  Close the writer, if necessary.

  Specified by:
    `close` in interface `HierarchicalStreamWriter`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004-2008 XStream. All Rights Reserved.